#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "window.h"

Display *display;
Window  windows[MAX_WINDOWS];
int screen;
int active_piece;
unsigned long foreground,background;
GC my_gc;
XSizeHints main_win_size;

int shades[17][4][4] =      /* grey scales for different colors */
	{
	{	{0, 0, 0, 0},
		{0, 0, 0, 0},
		{0, 0, 0, 0},
		{0, 0, 0, 0}},

	{	{0, 0, 0, 0},
		{0, 0, 0, 0},
		{0, 0, 1, 0},
		{0, 0, 0, 0}},

	{	{0, 0, 0, 0},
		{0, 1, 0, 0},
		{0, 0, 1, 0},
		{0, 0, 0, 0}},

	{	{0, 0, 0, 1},
		{0, 1, 0, 0},
		{0, 0, 1, 0},
		{0, 0, 0, 0}},

	{	{0, 0, 0, 1},
		{0, 1, 0, 0},
		{0, 0, 1, 0},
		{1, 0, 0, 0}},

	{	{0, 0, 0, 1},
		{0, 1, 0, 0},
		{0, 1, 1, 0},
		{1, 0, 0, 0}},

	{	{0, 0, 0, 1},
		{0, 1, 0, 0},
		{0, 1, 1, 1},
		{1, 0, 0, 0}},

	{	{1, 0, 0, 1},
		{0, 1, 0, 0},
		{0, 1, 1, 1},
		{1, 0, 0, 0}},

	{	{1, 0, 0, 1},
		{0, 1, 0, 0},
		{0, 1, 1, 1},
		{1, 0, 1, 0}},

	{	{1, 0, 1, 1},
		{0, 1, 0, 0},
		{0, 1, 1, 1},
		{1, 0, 1, 0}},

	{	{1, 0, 1, 1},
		{1, 1, 0, 0},
		{0, 1, 1, 1},
		{1, 0, 1, 0}},

	{	{1, 0, 1, 1},
		{1, 1, 1, 0},
		{0, 1, 1, 1},
		{1, 0, 1, 0}},

	{	{1, 0, 1, 1},
		{1, 1, 1, 0},
		{0, 1, 1, 1},
		{1, 0, 1, 1}},

	{	{1, 0, 1, 1},
		{1, 1, 1, 0},
		{0, 1, 1, 1},
		{1, 1, 1, 1}},

	{	{1, 0, 1, 1},
		{1, 1, 1, 0},
		{1, 1, 1, 1},
		{1, 1, 1, 1}},

	{	{1, 1, 1, 1},
		{1, 1, 1, 0},
		{1, 1, 1, 1},
		{1, 1, 1, 1}},

	{	{1, 1, 1, 1},
		{1, 1, 1, 1},
		{1, 1, 1, 1},
		{1, 1, 1, 1}}
	};

void init_windows(void)
	{
	extern Display *display;
	extern int screen;
	extern unsigned long foreground,background;
	extern Window windows[MAX_WINDOWS];
	extern XSizeHints main_win_size;
	extern GC my_gc;
	char title[20] = "Picture time";
        int i;
	printf("opening display\n");
	display = XOpenDisplay("");
	screen = DefaultScreen(display);
	foreground = BlackPixel(display,screen);
        background = WhitePixel(display,screen);
	windows[main_win] = XCreateSimpleWindow(display,DefaultRootWindow(display)
			,1,1,750,650,PPosition | PSize,foreground,background);
	XMapWindow(display,windows[main_win]);
	XSelectInput(display,windows[main_win],ExposureMask);
	main_win_size.x=1;
	main_win_size.y=1;
	main_win_size.width = 750;
	main_win_size.height = 650;
	main_win_size.flags = PPosition | PSize;
	XSetStandardProperties(display,windows[main_win],title,title,None,
				None,None,&main_win_size);
	my_gc = XCreateGC(display,windows[main_win],0,0);
	XSetBackground(display,my_gc,background);
	XSetForeground(display,my_gc,foreground);
	windows[z_buffer] =  XCreateSimpleWindow(display,windows[main_win],
		20,20,300,300,2,foreground,background);
	XSelectInput(display,windows[z_buffer],ButtonPressMask| ExposureMask);
	XMapWindow(display,windows[z_buffer]);


	for(i=select_win;i<=select_piece;i++)
		{
		windows[i] =  XCreateSimpleWindow(display,windows[main_win],
			360,(360 + ((i-select_win) * 40)),90,30,2,foreground,background);
		XSelectInput(display,windows[i],ButtonPressMask| ExposureMask);
		XMapWindow(display,windows[i]);
		}

	for(i=rotx;i<=rotz;i++)
		{
		windows[i] =  XCreateSimpleWindow(display,windows[main_win],
			460,(360 + ((i-rotx) * 40)),90,30,2,foreground,background);
		XSelectInput(display,windows[i],ButtonPressMask| ExposureMask);
		XMapWindow(display,windows[i]);
		}

	for(i=transx;i<=transz;i++)
		{
		windows[i] =  XCreateSimpleWindow(display,windows[main_win],
			560,(360 + ((i- transx) * 40)),90,30,2,foreground,background);
		XSelectInput(display,windows[i],ButtonPressMask| ExposureMask);
		XMapWindow(display,windows[i]);
		}
	for(i=dist_selection;i<=angle_selection;i++)
		{
		windows[i] =  XCreateSimpleWindow(display,windows[main_win],
			360,(470 + ((i- dist_selection) * 45)),90,30,2,foreground,background);
		XSelectInput(display,windows[i],ButtonPressMask| ExposureMask);
		XMapWindow(display,windows[i]);
		}
	windows[quit] =  XCreateSimpleWindow(display,windows[main_win],
		560,560,90,30,2,foreground,background);
	XSelectInput(display,windows[quit],ButtonPressMask| ExposureMask);
	XMapWindow(display,windows[quit]);
	}

void draw_pixel(int x, int y, int color)
	{
	extern int shades[17][4][4];
	extern Display *display;
	extern Window windows[MAX_WINDOWS];
	extern GC my_gc;

	int screenx,screeny;
	int i,j;
	/* the screen is mapped four * four pixels to a point. */
	screenx = x * 4;
	screeny = y * 4;
	for (i=0;i<4 ; i++)
		for (j=0;j<4;j++)
			{
			if (shades[color][i][j])
				XDrawPoint(display,windows[z_buffer],my_gc,screenx + i, screeny + j);
			else
				XDrawPoint(display,windows[z_buffer],my_gc,screenx + i, screeny + j);/* need to clear the area */

			}
	}
