#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>
#include <stdlib.h>
#include "transfor.h"
#include "pieces.h"
#include "z_buffer.h"
#include "window.h"
double the_z_buffer[50][50];
/* info required for view */
trans_matrix object_to_world_trans[5];
trans_matrix z_buffer_world_to_view_trans;

wall *walls[3];
sphere *spheres[2];
my_circle *circles[3];


void init_z_buffer_data()
	{
/*	trans_matrix temp;
	int i; */
	extern wall *walls[3];
	extern sphere *spheres[2];
	extern trans_matrix object_to_world_trans[5];
	printf("doing wall1\n");
	walls[0] = wall4();
	printf("doing sphere\n");
	spheres[0] = sphere1();
	spheres[1] = sphere2();

	identity(object_to_world_trans[0]);
	object_to_world_trans[0][0][3] = 5;
	object_to_world_trans[0][1][3] = 5;
	object_to_world_trans[0][2][3] = 5;

	object_to_world_trans[0][1][1] = 5;
	object_to_world_trans[0][2][2] = 5;
	object_to_world_trans[0][0][0] = 5;

	identity(object_to_world_trans[1]);
	object_to_world_trans[1][0][3] = 200;
	object_to_world_trans[1][1][3] = 40;
	object_to_world_trans[1][2][3] = 20;

	object_to_world_trans[1][1][1] = 5;
	object_to_world_trans[1][2][2] = 5;
	object_to_world_trans[1][0][0] = 5;

	identity(object_to_world_trans[2]);
	object_to_world_trans[2][0][3] = 20;
	object_to_world_trans[2][1][3] = 50;
	object_to_world_trans[2][2][3] = 50;

	object_to_world_trans[2][1][1] = 7;
	object_to_world_trans[2][2][2] = 7;
	object_to_world_trans[2][0][0] = 7;


	}
int dist_to_wall(wall *the_wall,int x, int y)
	{
	extern trans_matrix object_to_world_trans[5];
/*	wall world_wall; */
	int i,j,k;
	int small_dist = maxdist;
	point temp;
	temp[0] = x;
	temp[1] = y;
	temp[2] = 0;
	for (j=0;j<15;j++)
		for (i = 0;i<12;i++)
			{
			if (point_in_triangle(temp,
						the_wall->triangles[j][i],
						the_wall->triangles[j][i+1],
						the_wall->triangles[j][i+2]))
				{
				k = point_z_location(temp,
						the_wall->triangles[j][i],
						the_wall->triangles[j][i+1],
						the_wall->triangles[j][i+2]);
				if (k < small_dist)
					small_dist = k;
				}
			}
	return small_dist;
	}
/* soon draw zbuffer of triangle */
#ifdef 0 /* Don't compile */
void update_z_buffer(int a_piece,point a,point b, point c)
	{
	int x,y;
	int maxx, maxy;
	int minx, miny;
	double dist;
	point temp;
	extern double the_z_buffer[50][50];
	extern wall *walls[3];
        extern sphere *spheres[2];
	/* find area to check triangle in */
	minx = a[0];
	miny = a[1];
	if (minx > b[0])
		minx = b[0];
	if (miny > b[1] )
		miny = b[1];
	if (minx > c[0])
		minx = c[0];
	if (miny > c[1])
		miny = c[1];

	maxx = a[0];
	maxy = a[1];
	if (maxx < b[0])
		maxx = b[0];
	if (maxy < b[1] )
		maxy = b[1];
	if (maxx < c[0])
		maxx = c[0];
	if (maxy < c[1])
		maxy = c[1];
	/* now check the triangle fits within the viewport */
	/* by converting min/max x,y to viewport and comparing with
	0,0 50,50 */

	for (x = minx;x<=maxx;x++)
		{
		temp[0] = x;
		for (y = miny;y<=maxy;y++)
			{
			temp[1] = y;
			if (point_in_triangle(temp,a,b,c))
				{
				dist = point_z_location(temp,a,b,c);
				/* transform from x,y to viewport */
				if (dist < the_z_buffer[x][y])
					the_z_buffer[x][y] = dist;
					if (a_piece <= 2)
						draw_pixel(x,y,walls[a_piece]->colour);
					else
						draw_pixel(x,y,spheres[a_piece]->colour);

				}
			}
		}
	}
#endif /* Don't compile */

/* for now draw wireframe of triangle */
void update_z_buffer(int a_piece,point a,point b, point c)
	{
	extern Display *display;
	extern Window windows[MAX_WINDOWS];
	extern GC my_gc;
/*	int x,y; */
	int maxx, maxy;
	int minx, miny;
	double dist;
	point temp;
	extern double the_z_buffer[50][50];
	extern wall *walls[3];
        extern sphere *spheres[2];

	/* find area to check triangle in */
	minx = a[0];
	miny = a[1];
	if (minx > b[0])
		minx = b[0];
	if (miny > b[1] )
		miny = b[1];
	if (minx > c[0])
		minx = c[0];
	if (miny > c[1])
		miny = c[1];

	maxx = a[0];
	maxy = a[1];
	if (maxx < b[0])
		maxx = b[0];
	if (maxy < b[1] )
		maxy = b[1];
	if (maxx < c[0])
		maxx = c[0];
	if (maxy < c[1])
		maxy = c[1];
	/* now check the triangle fits within the viewport */
	/* by converting min/max x,y to viewport and comparing with
	0,0 50,50 */
/*	printf("drawing lines %f %f %f %f %f %f\n",
		a[0],a[1],b[0],b[1],c[0],c[1]);
*/	
XDrawLine(display,windows[z_buffer],my_gc,a[0],a[1],b[0],b[1]);
	
XDrawLine(display,windows[z_buffer],my_gc,a[0],a[1],c[0],c[1]);
	
XDrawLine(display,windows[z_buffer],my_gc,b[0],b[1],c[0],c[1]);
/*		}
*/
}
void draw_z_buffer()
	{
	int w;
	int i,j,k;
	point a,b,c;
	extern wall *walls[3];
	extern sphere *spheres[2];
	extern trans_matrix object_to_world_trans[5];
	extern Display *display;
	extern Window windows[MAX_WINDOWS];
	/* clear the area */
	XClearWindow(display,windows[z_buffer]);

	for (i = 0;i<1;i++)       		/* for each wall piece */
		for (j=0;j<15;j++)      		/* for each block*/
		    for (k=0;k<12;k++)				/* for each triangle */
			{
			/* calculate real position of triangle points */
			vector_mult(walls[i]->triangles[j][k],
				    object_to_world_trans[i], a);
			vector_mult(walls[i]->triangles[j][k+1],
				    object_to_world_trans[i],
				    b);
			vector_mult(walls[i]->triangles[j][k+2],
				    object_to_world_trans[i],
				    c);
			/* then pass them to the calculation part of the program */
			update_z_buffer(i,a,b,c);
			}

	for (i = 0;i<2;i++)       		/* for each sphere piece */
		for (j=0;j<16;j++)      	/*	 for each block */
		    for (k=0;k<14;k++)			/*	 for each triangle */
			{
			/* calculate real position of triangle points */
			vector_mult(spheres[i]->triangles[j][k],
				    object_to_world_trans[i+1],
				    a);
			vector_mult(spheres[i]->triangles[j][k+1],
				    object_to_world_trans[i+1],
				    b);
			vector_mult(spheres[i]->triangles[j][k+2],
				    object_to_world_trans[i+1],
				    c);
			/* then pass them to the calculation part of the program */ 
			update_z_buffer(i,a,b,c);
			}
		/* now do circles on sphere1 */
	for (i = 0; i < 3 ; i++)
		for (j = 1; j< 17;j++)
			{
			vector_mult(circles[i]->triangles[0],
				    object_to_world_trans[1],
				    a);
			vector_mult(circles[i]->triangles[j],
				    object_to_world_trans[1],
				    b);
			vector_mult(circles[i]->triangles[j+1%17],
				    object_to_world_trans[1],
				    c);
			/* then pass them to the calculation part of the program */
			update_z_buffer(i,a,b,c);
			}


	}
