#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <string.h>
#include <math.h>
#include "transfor.h"
#include "main.h"
#include "window.h"
#include "z_buffer.h"
double distance_delta(int x)
	{
	return (float)(x-45.0)/6.0;
	}
double angle_delta(int x)
	{
	return (float)(x-45.0)/50.0;
	}
boolean handle_event(void)
	{
	extern trans_matrix object_to_world_trans[5];
	int i;
	int active_piece = 0,active_method = 0;
	double active_distance = 0.0;
	double active_angle = 0.0;
	extern Window windows[MAX_WINDOWS];
	extern Display *display;
	extern GC my_gc;
	XEvent event;
	char active_dist_str[5] ;
	char active_angle_str[5] ;
	trans_matrix temp;
	char methods[3][9] = {  "Z Buffer ",
				"wire     ",
				"Scan Line"};

	char pieces[8][9] = {	"Wall 1   ",
				"Sphere   ",
				"D-Sphere ",
				"Wall 2   ",
				"Wall 3   "};
	sprintf(active_angle_str,"%f",(active_angle / 6.2831854) * 360.0);
	sprintf(active_dist_str,"%f",(float)active_distance);

	while (1)
		{
		XNextEvent(display,&event); /* get next xevent in a structure */
		switch (event.type)
			{
			case Expose:  /* redraw window information */

				XDrawImageString(display,windows[z_buffer],my_gc,20,10,"Z buffer ",9);
				XDrawImageString(display,windows[select_win],my_gc,20,10,methods[active_method],9);
				XDrawImageString(display,windows[select_piece],my_gc,20,10,pieces[active_piece],8);
				XDrawImageString(display,windows[rotx],my_gc,20,10,"Rotate X",8);
				XDrawImageString(display,windows[roty],my_gc,20,10,"Rotate Y",8);
				XDrawImageString(display,windows[rotz],my_gc,20,10,"Rotate Z",8);
				XDrawImageString(display,windows[transx],my_gc,20,10,"Translate X",11);
				XDrawImageString(display,windows[transy],my_gc,20,10,"Translate Y",11);
				XDrawImageString(display,windows[transz],my_gc,20,10,"Translate Z",11);
				XDrawImageString(display,windows[dist_selection],my_gc,20,10,active_dist_str,5);
				XDrawImageString(display,windows[dist_selection],my_gc,20,25,"distance",8);
				XDrawImageString(display,windows[main_win],my_gc,363,514,"--  -  0  +  ++",15);
				XDrawImageString(display,windows[angle_selection],my_gc,20,10,active_angle_str,5);
			  	XDrawImageString(display,windows[angle_selection],my_gc,20,25,"angle",5);
				XDrawImageString(display,windows[quit],my_gc,20,10,"Quit",4);
				printf("doing z buffer now \n");
				draw_z_buffer();
				/* seem to get about 12 exposes in a row so
				get rid of rest of them. this has bug of next mouse click is
                                lost */
				while (event.type == Expose)
					XNextEvent(display,&event);
				break;

			case ButtonPress :
				for(i=0;i<MAX_WINDOWS;i++)
					if (event.xbutton.window == windows[i])
						switch (i)
							{
							case main_win	: break;

							case quit 		: return true;

							case select_win		: active_method = (active_method + 1) % 3;
										  XDrawImageString(display,windows[select_win],my_gc,20,10,methods[active_method],9);
										  break;
							case select_piece	: active_piece = (active_piece +1) % 5;
										  XDrawImageString(display,windows[select_piece],my_gc,20,10,pieces[active_piece],8);
										  break;
							case rotx    		: rotate_x(temp,active_angle);
										  concat_trans_matricies(object_to_world_trans[active_piece],temp,object_to_world_trans[active_piece]);
										  break;
							case roty    		: rotate_y(temp,active_angle);
										  concat_trans_matricies(object_to_world_trans[active_piece],temp,object_to_world_trans[active_piece]);
										  break;
							case rotz    		: rotate_z(temp,active_angle);
										  concat_trans_matricies(object_to_world_trans[active_piece],temp,object_to_world_trans[active_piece]);
										  break;
							case transx  		: object_to_world_trans[active_piece][0][3] += active_distance;
										  break;
							case transy  		: object_to_world_trans[active_piece][1][3] += active_distance;
										  break;
							case transz		: object_to_world_trans[active_piece][2][3] += active_distance;
										  break;
							case dist_selection  	: active_distance += distance_delta(event.xbutton.x);
										  /* now display the new value */
										  sprintf(active_dist_str,"%f",active_distance);
										  XDrawImageString(display,windows[dist_selection],my_gc,20,10,active_dist_str,5);
									/*	  XDrawImageString(display,windows[dist_selection],my_gc,20,10,"distance",8);
									*/  	  break;
							case angle_selection 	: active_angle += angle_delta(event.xbutton.x);
										  sprintf(active_angle_str,"%f",(active_angle / 6.2831854) * 360.0);
										  XDrawImageString(display,windows[angle_selection],my_gc,20,10,active_angle_str,5);
									/*	  XDrawImageString(display,windows[angle_selection],my_gc,20,10,"angle",5);
									*/	  break;
                                                	} /* switch */
	        	}/* switch */
		draw_z_buffer();

	 	}/*while*/                           

        }

void main(void)
	{
	init_z_buffer_data();
	init_windows();
	while (!handle_event());
	}