#include <stdlib.h>
#include <stdio.h>
#include "transfor.h"
#include "pieces.h"
point  triangles_for_a_block[14] ={	 {0,0,0,1},
					 {0,2,0,1},
					 {4,0,0,1},
					 {4,2,0,1},
					 {4,2,1,1},
					 {0,2,0,1},
					 {0,2,1,1},
					 {0,0,0,1},
					 {0,0,1,1},
					 {4,0,0,1},
					 {4,0,1,1},
					 {4,2,1,1},
					 {0,0,1,1},
					 {0,2,1,1}} ;
void print_point(point a)
	{
	printf("%f %f %f\n",a[0],a[1],a[2]);
	}
my_circle *base_circle(double sphere_radius,
		    double circle_radius,
		    trans_matrix the_matrix)
	{
	int i;
	double angle;
	my_circle *new_circle;
	trans_matrix matrix1,matrix2;
	point a_point = {0,0,0,1},new_point;

	new_circle = (my_circle *)(malloc(sizeof(my_circle)));

	a_point[0] = sphere_radius + 0.01;

	vector_copy(new_circle->triangles[0],a_point);
	/* calculate the angle to rotate by to get circle
	radius */
	angle = (circle_radius/sphere_radius);
	rotate_y(matrix1,angle);
	vector_mult(a_point,matrix1,a_point);


	for ( i= 0;i<17;i++)
		{
		vector_copy(new_point,a_point);
		rotate_x(matrix2,(double)i * PI/8);
		vector_mult(new_point,matrix2,new_point);

		vector_copy(new_circle->triangles[i+1],new_point);
		}

	for (i=0;i<18;i++)
		vector_mult(new_circle->triangles[i],the_matrix,new_circle->triangles[i]);

	return new_circle;
	}

wall *wall1()
	{
	int i,j,l = 0,k = 0;
	extern point triangles_for_a_block[14];
	wall * new_wall;
	piece *new_piece;
	new_piece = (piece *)(malloc(sizeof(piece)));
	new_wall = (wall *)(malloc(sizeof(wall)));
	for (j = 5;j>0;j--)
		{
		for (i=0;i<j;i++)
			{
			new_piece->block[k][0] = i * 4  + l;
			new_piece->block[k][1] = (5 - j) * 2;
			new_piece->block[k][2] = 0;
			new_piece->block[k][3] = 1;
			k++;
			}
		l+=2;
		}
	for (i = 0;i<15;i++)
		for (j=0;j<14;j++)
			{
			vector_add(new_wall->triangles[i][j],new_piece->block[i],triangles_for_a_block[j]);
			}
	new_wall->colour = 7;
	return new_wall;
	};
wall *wall4()
	{
	int i,j,l = 0,k = 0;
	extern point triangles_for_a_block[14];
	wall * new_wall;
	piece *new_piece;
	new_piece = (piece *)(malloc(sizeof(piece)));
	new_wall = (wall *)(malloc(sizeof(wall)));

	for (i=0;i<5;i++) /* lowest level */
		{
		new_piece->block[k][0] = i * 4;	/* x */
		new_piece->block[k][1] = 0;		/* y */
		new_piece->block[k][2] = 0;		/* z  const */
		new_piece->block[k][3] = 1;		/* w  const*/
		k++;
		}
	/* second level */		
	new_piece->block[k][0] = 2;		/* x */
	new_piece->block[k][1] = 2;		/* y */
	new_piece->block[k][2] = 0;		/* z  const */
	new_piece->block[k][3] = 1;		/* w  const*/
	k++;		
	new_piece->block[k][0] = 14;		/* x */
	new_piece->block[k][1] = 2;		/* y */
	new_piece->block[k][2] = 0;		/* z  const */
	new_piece->block[k][3] = 1;		/* w  const*/
	k++;

	/* third level */		
	new_piece->block[k][0] = 4;		/* x */
	new_piece->block[k][1] = 4;		/* y */
	new_piece->block[k][2] = 0;		/* z  const */
	new_piece->block[k][3] = 1;		/* w  const*/
	k++;		
	new_piece->block[k][0] = 12;		/* x */
	new_piece->block[k][1] = 4;		/* y */
	new_piece->block[k][2] = 0;		/* z  const */
	new_piece->block[k][3] = 1;		/* w  const*/
	k++;

	/* fourth level */		
	new_piece->block[k][0] = 6;		/* x */
	new_piece->block[k][1] = 6;		/* y */
	new_piece->block[k][2] = 0;		/* z  const */
	new_piece->block[k][3] = 1;		/* w  const*/
	k++;		
	new_piece->block[k][0] = 10;		/* x */
	new_piece->block[k][1] = 6;		/* y */
	new_piece->block[k][2] = 0;		/* z  const */
	new_piece->block[k][3] = 1;		/* w  const*/
	k++;

	/* fifth level */		
	new_piece->block[k][0] = 4;		/* x */
	new_piece->block[k][1] = 8;		/* y */
	new_piece->block[k][2] = 0;		/* z  const */
	new_piece->block[k][3] = 1;		/* w  const*/
	k++;		
	new_piece->block[k][0] = 12;		/* x */
	new_piece->block[k][1] = 8;		/* y */
	new_piece->block[k][2] = 0;		/* z  const */
	new_piece->block[k][3] = 1;		/* w  const*/
	k++;

	/* sixth level */		
	new_piece->block[k][0] = 6;		/* x */
	new_piece->block[k][1] = 10;		/* y */
	new_piece->block[k][2] = 0;		/* z  const */
	new_piece->block[k][3] = 1;		/* w  const*/
	k++;		
	new_piece->block[k][0] = 10;		/* x */
	new_piece->block[k][1] = 10;		/* y */
	new_piece->block[k][2] = 0;		/* z  const */
	new_piece->block[k][3] = 1;		/* w  const*/
	k++;

	/* create triangles */
	for (i = 0;i<15;i++)
		for (j=0;j<14;j++)
			{
			vector_add(new_wall->triangles[i][j],new_piece->block[i],triangles_for_a_block[j]);
			}
	new_wall->colour = 7;
	return new_wall;
	};
wall *wall3()
	{
	int i,j,l = 0,k = 0;
	extern point triangles_for_a_block[14];
	wall * new_wall;
	piece *new_piece;
	new_piece = (piece *)(malloc(sizeof(piece)));
	new_wall = (wall *)(malloc(sizeof(wall)));

	for (i=0;i<4;i++) /* lowest level */
		{
		new_piece->block[k][0] = 2 + i * 4;	/* x */
		new_piece->block[k][1] = 0;		/* y */
		new_piece->block[k][2] = 0;		/* z  const */
		new_piece->block[k][3] = 1;		/* w  const*/
		k++;
		}
	/* second level */		
	new_piece->block[k][0] = 0;		/* x */
	new_piece->block[k][1] = 2;		/* y */
	new_piece->block[k][2] = 0;		/* z  const */
	new_piece->block[k][3] = 1;		/* w  const*/
	k++;		
	new_piece->block[k][0] = 8;		/* x */
	new_piece->block[k][1] = 2;		/* y */
	new_piece->block[k][2] = 0;		/* z  const */
	new_piece->block[k][3] = 1;		/* w  const*/
	k++;
	new_piece->block[k][0] = 16;		/* x */
	new_piece->block[k][1] = 2;		/* y */
	new_piece->block[k][2] = 0;		/* z  const */
	new_piece->block[k][3] = 1;		/* w  const*/
	k++;

	for (i=0;i<4;i++) /* third level */
			{
			new_piece->block[k][0] = 2 + i * 4;		/* x */
			new_piece->block[k][1] = 4;		/* y */
			new_piece->block[k][2] = 0;		/* z  const */
			new_piece->block[k][3] = 1;		/* w  const*/
			k++;
			}

	/* fourth level */
	new_piece->block[k][0] = 4;		/* x */
	new_piece->block[k][1] = 6;		/* y */
	new_piece->block[k][2] = 0;		/* z  const */
	new_piece->block[k][3] = 1;		/* w  const*/
	k++;
	new_piece->block[k][0] = 12;		/* x */
	new_piece->block[k][1] = 6;		/* y */
	new_piece->block[k][2] = 0;		/* z  const */
	new_piece->block[k][3] = 1;		/* w  const*/
	k++;

	/* fifth level */
	new_piece->block[k][0] = 6;		/* x */
	new_piece->block[k][1] = 8;		/* y */
	new_piece->block[k][2] = 0;		/* z  const */
	new_piece->block[k][3] = 1;		/* w  const*/
	k++;
	new_piece->block[k][0] = 10;		/* x */
	new_piece->block[k][1] = 8;		/* y */
	new_piece->block[k][2] = 0;		/* z  const */
	new_piece->block[k][3] = 1;		/* w  const*/
	k++;

	/* create triangles for wall */
	for (i = 0;i<15;i++)
		for (j=0;j<14;j++)
			{
			vector_add(new_wall->triangles[i][j],new_piece->block[i],triangles_for_a_block[j]);
			}
	new_wall->colour = 7;
	return new_wall;
	};
wall *wall2()
	{
	int i,j,l = 0,k = 0;
	extern point triangles_for_a_block[14];
	wall * new_wall;
	piece *new_piece;
	new_piece = (piece *)(malloc(sizeof(piece)));
	new_wall = (wall *)(malloc(sizeof(wall)));
	/* create the positions of the blocks. There are 15 blocks and we need to set x,y,z,w */

	for (i=0;i<3;i++) /* lowest level */
		{
		new_piece->block[k][0] = (i+1) * 4;	/* x */
		new_piece->block[k][1] = 0;		/* y */
		new_piece->block[k][2] = 0;		/* z  const */
		new_piece->block[k][3] = 1;		/* w  const*/
		k++;
		}

	/* second level */		
	new_piece->block[k][0] = 2;		/* x */
	new_piece->block[k][1] = 2;		/* y */
	new_piece->block[k][2] = 0;		/* z  const */
	new_piece->block[k][3] = 1;		/* w  const*/
	k++;		
	new_piece->block[k][0] = 14;		/* x */
	new_piece->block[k][1] = 2;		/* y */
	new_piece->block[k][2] = 0;		/* z  const */
	new_piece->block[k][3] = 1;		/* w  const*/
	k++;
			
	for (i=0;i<5;i++) /* third level */
			{
			new_piece->block[k][0] = i * 4;		/* x */
			new_piece->block[k][1] = 4;		/* y */
			new_piece->block[k][2] = 0;		/* z  const */
			new_piece->block[k][3] = 1;		/* w  const*/
			k++;
			}
	for (i=0;i<4;i++) /* fourth level */
			{
			new_piece->block[k][0] = 2 + i * 4;		/* x */
			new_piece->block[k][1] = 6;		/* y */
			new_piece->block[k][2] = 0;		/* z  const */
			new_piece->block[k][3] = 1;		/* w  const*/
			k++;
			}

	/* top level */
	new_piece->block[k][0] = 8;		/* x */
	new_piece->block[k][1] = 8;		/* y */
	new_piece->block[k][2] = 0;		/* z  const */
	new_piece->block[k][3] = 1;		/* w  const*/
	k++;




	/* create the triangles, same for all blocks */
	for (i = 0;i<15;i++)
		for (j=0;j<14;j++)
			{
			vector_add(new_wall->triangles[i][j],new_piece->block[i],triangles_for_a_block[j]);
			}
	new_wall->colour = 5;
	return new_wall;
	
	}

sphere *sphere1()
	{
	int z;
	double radius = 7;
	int x,y;
	extern my_circle *circles[3];
	point new_points[8];
	point a_point = {0,0,0,1},new_point;
	trans_matrix matrix1,matrix2;
	sphere *new_sphere;
	new_sphere = (sphere *)(malloc(sizeof(sphere)));


	/* need to construct triangles for sphere surface */
	/* do this by slicing sphere into circles then
	getting points on circles and combining them.
	the end of the sphere is treated differently */
	/* the sphere is broken up into 15 slabs that wrap
	from pole to pole. each slab has 14 triangles on it */
	/* starting at the x axis the points are calculated by
	rotating about y in multiples of 22.5 degrees (PI/8)
	and then about x in multiples of 22.5 degrees (pi/8)
	can construct all the slabs in one loop of the first
	increment. */
	a_point[0] = radius;

	for (z = 0;z<16;z++)
		{
		vector_copy(new_sphere->triangles[z][0],a_point);
		}

	a_point[0] *= -1;
	for (z = 0;z<16;z++)
		{
		vector_copy(new_sphere->triangles[z][15],a_point);
		}

	a_point[0] *= -1;

	for (y = 0; y< 16 ; y ++)
		for (x = 1;x<8;x++)
			{
			/* calc transform for these angles */
			vector_copy(new_point,a_point);
			rotate_y(matrix1,(double)x * PI / 8.0);
			vector_mult(new_point,matrix1,new_point);
			rotate_x(matrix1,(double)y * PI / 8.0);
			vector_mult(new_point,matrix1,new_point);
			/* then mult vector by it */

			vector_copy(new_sphere->triangles[y][x*2-1],new_point);
			vector_copy(new_sphere->triangles[(y+1)%16][x*2],new_point);
			}
	/* do circles */
	for (y = 1;y<4;y++)
		{
		/* calc a location on sphere to place circle */
		rotate_y(matrix1,(double)y);
		rotate_z(matrix2,(double)y);

		concat_trans_matricies(matrix1,matrix2,matrix1);


		/* create the circle */
		circles[y-1] = base_circle(radius,(double)y,matrix1);
		}
	return new_sphere;
	}
sphere *sphere2()
	{
	int z;
	double radius = 2;
	int x,y;
	point new_points[8];
	point a_point = {0,0,0,1},new_point;
	trans_matrix matrix1,matrix2;
	sphere *new_sphere;
	new_sphere = (sphere *)(malloc(sizeof(sphere)));

	/* need to construct triangles for sphere surface */
	/* do this by slicing sphere into circles then
	getting points on circles and combining them.
	the end of the sphere is treated differently */
	/* the sphere is broken up into 15 slabs that wrap
	from pole to pole. each slab has 14 triangles on it */
	/* starting at the x axis the points are calculated by
	rotating about y in multiples of 22.5 degrees (PI/8)
	and then about x in multiples of 22.5 degrees (pi/8)
	can construct all the slabs in one loop of the first
	increment. */
	a_point[0] = radius;


	for (z = 0;z<16;z++)
		{
		vector_copy(new_sphere->triangles[z][0],a_point);
		}

	a_point[0] *= -1;
	for (z = 0;z<16;z++)
		{
		vector_copy(new_sphere->triangles[z][15],a_point);
		}

	a_point[0] = 0;
	for (x = 0;x<15;x++)
		for (y= 1;y<15;y++)
			vector_copy(new_sphere->triangles[x][y],a_point);

	a_point[0] = radius;
	for (y = 0; y< 16 ; y ++)
		for (x = 1;x<8;x++)
			{
			/* calc transform for these angles */
			vector_copy(new_point,a_point);
			rotate_y(matrix1,(double)x * PI / 8.0);
			vector_mult(new_point,matrix1,new_point);
			rotate_x(matrix1,(double)y * PI / 8.0);
			vector_mult(new_point,matrix1,new_point);
			/* then mult vector by it */

			vector_copy(new_sphere->triangles[y][x*2-1],new_point);
			vector_copy(new_sphere->triangles[(y+1)%16][x*2],new_point);
			}
	return new_sphere;
	}