//#include <X11/Xlib.h>
//#include <X11/Xutil.h>
#define ambient_light 0.3
#define num_spheres 2
#define num_lights 2
#define max_depth 2
#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <graphics.h>
#include "transfor.h"
#include "pieces.h"
#include "ray_trac.h"
#include "window.h"
typedef enum {glass,air} mediums;
sphere *spheres[num_spheres];
light_source *lights[num_lights];
char the_window[win_size][win_size];
int shades[10][3][3] =      /* grey scales for different colors */
	{
	{	{0, 0, 0},
		{0, 0, 0},
		{0, 0, 0}},

	{	{0, 1, 0},
		{0, 0, 0},
		{0, 0, 0}},

	{	{0, 1, 0},
		{0, 0, 0},
		{0, 0, 1}},

	{	{0, 1, 0},
		{1, 0, 0},
		{0, 0, 1}},

	{	{0, 1, 0},
		{1, 1, 0},
		{0, 0, 1}},

	{	{0, 1, 0},
		{1, 1, 0},
		{1, 0, 1}},

	{	{0, 1, 1},
		{1, 1, 0},
		{1, 0, 1}},

	{	{0, 1, 1},
		{1, 1, 0},
		{1, 1, 1}},

	{	{1, 1, 1},
		{1, 1, 0},
		{1, 1, 1}},

	{	{1, 1, 1},
		{1, 1, 1},
		{1, 1, 1}}
	};;

void make_ray(light_ray *ray, point a/* start */, point b/* end */)
	{
	point dirn = {0,0,0,1};
	vector_copy(ray->start,a);
	vector_from_points(a,b,dirn);
	normalise(dirn);
	vector_copy(ray->dirn,dirn);
	ray->refractive_index = 1 ;
	}
void draw_pixel(int x, int y, int color)
	{
	extern int shades[10][3][3];

//	extern Display *display;
//	extern Window windows[MAX_WINDOWS];
//	extern GC my_gc;
	int screenx,screeny;
	int i,j;
	screenx = x * 3;
	screeny = y * 3;

	if (color > 9 ) color = 9;
	if (color < 0 ) color = 0;
	for (i=0;i<3 ; i++)
		for (j=0;j<3;j++)
			if (shades[color][i][j])
				putpixel(screenx + i, screeny + j,15);
//				XDrawPoint(display,windows[rtrace],my_gc,screenx + i, screeny + j);

	}


double distance_to_sphere(int sphere_no,light_ray ray)
	{
	extern sphere *spheres[num_spheres];
	/* x = (-b (+-) sqrt(b^2 -4ac))/2a */
	double a,b,c,temp,result1,result2;

	a = ray.dirn[0]*ray.dirn[0] +
	    ray.dirn[1]*ray.dirn[1] +
	    ray.dirn[2]*ray.dirn[2];

	b = 2 *((ray.dirn[0] * (ray.start[0] - spheres[sphere_no]->location[0])) +
		(ray.dirn[1] * (ray.start[1] - spheres[sphere_no]->location[1])) +
		(ray.dirn[2] * (ray.start[2] - spheres[sphere_no]->location[2])));

	c = 	pow(ray.start[0] - spheres[sphere_no]->location[0],2.0) +
		pow(ray.start[1] - spheres[sphere_no]->location[1],2.0) +
		pow(ray.start[2] - spheres[sphere_no]->location[2],2.0) -
		pow(spheres[sphere_no]->radius,2.0);

	temp = b*b - 4.0*a*c;
	if (temp >= 0.0)
		{
		result1 = (-b + sqrt(temp))/ 2.0 * a;
		result2 = (-b - sqrt(temp))/ 2.0 * a;
		if (result1 > 0.2)
			if (result2> 0.2)
				if (result1 < result2)
					return result1;
				else
					return result2;
			else
				return result1;
		else
			if (result2 > 0.2)
				return result2;
			else
				{
				return -1;
				}
		}
	else
		/* no intersection with this sphere */
		return -1;/* ???*/

	}

void intersection_point(point intersection,light_ray ray,double distance)
	{
	intersection[0] = ray.start[0] + ray.dirn[0] * distance;
	intersection[1] = ray.start[1] + ray.dirn[1] * distance;
	intersection[2] = ray.start[2] + ray.dirn[2] * distance;
	}


double RT_shade(int object,light_ray ray,point intersection,point normal,int depth, int medium, double light_acc_dist)
	{
	extern sphere *spheres[num_spheres];
	extern light_source *lights[num_lights];

	double temp1,temp2;
	point vect1 = {0,0,0,1},vect2 = {0,0,0,1};
	light_ray new_ray;
	double new_dist;
	float colour,r_colour,t_colour;
	int i;
	point inter_to_light = {0,0,0,1};
	point reflected = {0,0,0,1},refracted = {0,0,0,1};
	point multd_norm = {0,0,0,1};

	colour = ambient_light * spheres[object]->amb_coef;
	if (depth > max_depth)
		return 0;

	for (i=0;i<num_lights;i++)
		{
		vector_from_points(lights[i]->location,intersection,inter_to_light);
		normalise(inter_to_light);
		if (dot_product(normal,inter_to_light) > 0.0) /* light falls on surface */
	
			{
			/* see if an object in the way of the light */
				make_ray(&new_ray,intersection,lights[i]->location);
				vector_copy(multd_norm,normal);
				if ((distance_to_sphere(1,new_ray) < 0.0))/* not intersecting */
					{
					/* sphere 1 not in way !! */
					vector_scalar_mult(multd_norm,2.0 * dot_product(multd_norm,inter_to_light));
					vector_from_points(inter_to_light,multd_norm,reflected);

					if ((distance_to_sphere(0,new_ray) < 0.0))/* not intersecting */
						{
						/* sphere 0 not in way */
						colour += spheres[object]->dif_coef * lights[i]->intensity *(4.0/(4.0 +(0.01 * light_acc_dist))) * dot_product(normal,inter_to_light);

						/* calc reflected light vector  */
						/* reflected ray is 2 * Normal * (Normal dot Ray) - Ray */
						vector_scalar_mult(multd_norm,2.0 * dot_product(multd_norm,inter_to_light));
						vector_from_points(inter_to_light,multd_norm,reflected);

						colour += spheres[object]->spe_coef * lights[i]->intensity*(4.0/(4.0 + (0.01 * light_acc_dist))) * pow(dot_product(reflected,ray.dirn),spheres[object]->spe_expo);
						}
				else

						{
						colour += spheres[object]->dif_coef * spheres[0]->refr_coef * lights[i]->intensity*(4.0/(4.0 + (0.01 *light_acc_dist)))* dot_product(normal,inter_to_light)* lights[i]->intensity;

						vector_scalar_mult(multd_norm,2.0 * dot_product(multd_norm,inter_to_light));
						vector_from_points(inter_to_light,multd_norm,reflected);
						colour += spheres[object]->spe_coef *spheres[0]->refr_coef* lights[i]->intensity *(4.0/(4.0 + (0.01 *light_acc_dist)))* pow(dot_product(reflected,ray.dirn),spheres[object]->spe_expo);

						}
					}

			}
		}

	/* end of method 1 */
	/* now do reflection */
	vector_copy(multd_norm,normal);
	if (spheres[object]->refl_coef > 0.0)
		/* object is reflective */
		{
		/* calc reflected ray */
		/* reflected ray is 2 * Normal * (Normal dot Ray) - Ray */

		for(i=0;i<3;i++)
			vect1[i] = -ray.dirn[i];

		temp1 = 2.0 * dot_product(normal,vect1);
		vector_scalar_mult(multd_norm,temp1);
		vector_from_points(vect1,multd_norm,reflected);
		if (vector_len(reflected) == 0.0)
			{
			printf("temp1 = %f\n",temp1);
			printf("multed_norm %f %f %f\n",multd_norm[0],multd_norm[1],multd_norm[2]);
			printf("ray.dirn    %f %f %f\n",ray.dirn[0],ray.dirn[1],ray.dirn[2]);
			}
		else
			{
			/* seems to hit zero length vector */
			/* reflected is the direction, need to add to intersection for
			make_ray to work correctly */
			vector_add(reflected,intersection,reflected);

			/* RT_trace reflected ray */
			make_ray(&new_ray,intersection,reflected);
			r_colour = RT_trace(new_ray,depth+1,air,light_acc_dist);
			/* scale result by spec_coef and add to colour */
//			printf("rcolour = %f\n",r_colour);

			r_colour *= spheres[object]->spe_coef /15 ;
			colour += r_colour;
			}
		}
	/* now for refraction */
	/* refracted ray goes straight, with new starting point */
		if (spheres[object]->refr_coef > 0.0)
//		if (medium == air)
			{
			/* calc refracted ray */
/*			temp1 = dot_product(normal,ray.dirn);
			temp2 = temp1 * temp1;
			temp2 = 1 - temp2;
			temp2 = temp2 * pow(spheres[object]->index_refr_coef,2.0);
			temp2 = 1 - temp2;
			if (temp2 > 0.01)
				{
				temp2 = sqrt(temp2);

				temp1 = temp1 * spheres[object]->index_refr_coef;
				temp1 = temp1 - temp2;
				vector_copy(vect1,normal);
				vector_copy(vect2,ray.dirn);
				vector_scalar_mult(vect1,temp1);
				vector_scalar_mult(vect2,spheres[object]->index_refr_coef);
				vector_from_points(vect2,vect1,refracted);

//				vector_add(refracted,intersection,refracted);
				/* as the angle out of the sphere = angle between refracted and
				normal at entry of sphere, we can check internal refraction by
				using these vectors */

				/* total internal reflection does not occur */
/*				//if (dot_product(normal,refracted) < 1.0)

*/
				vector_copy(vect1,ray.dirn);
				vector_add(vect1,intersection,vect1);
				make_ray(&new_ray,intersection,vect1);

				t_colour = RT_trace(ray,depth+1,glass,light_acc_dist) / 15;
//				printf("tcolour = %f\n",t_colour);
				colour += t_colour;
//				}
			}
/*		else
			{
			 medium = glass */
			/*calc angle of new refracted ray */
/*			colour += 0.5;
*/			/* then RT_TRACE it */
			/* make ray go straight */
//			vector_add(vect1,ray.dirn,intersection);
//			make_ray(&new_ray,intersection,vect1);
//			t_colour = RT_trace(new_ray,depth+1,glass);
//			colour += t_colour;

//			}


	
	return (colour);
	}

char RT_trace(light_ray ray, int depth,int medium,double light_acc_dist)
	{
	extern sphere *spheres[num_spheres];
	extern light_source *lights[num_lights];
	int i;
	double distance1,distance2 = 5000;
	point normal, intersection;

	int object;

	for (i = 0;i<num_spheres;i++)
		{
		distance1 = distance_to_sphere(i,ray);
		if (distance1 > 0.001)
			if (distance1 < distance2)
				{
				distance2 = distance1;
				object = i;
				}
		}
	if (distance2 < 5000)
		{
		/* we have hit a sphere */
		/* compute normal to sphere at intersection */
		intersection_point(intersection,ray,distance2);
		vector_from_points(intersection,spheres[object]->location,normal);
		/* make normal unit length */
		normalise(normal);
		light_acc_dist += distance2;
/*//		printf("%d\n",(int)(RT_shade(object,ray,intersection,normal,depth) * 18.0 - 3.0 ) );
*/		return (int)(RT_shade(object,ray,intersection,normal,depth,medium, light_acc_dist) * 40 + 1) ;
		}                                                               /* * 18 -3 */
	else
		{
		return 0;
		}

	}


void ray_trace(void)
	{
	extern sphere *spheres[num_spheres];
	extern light_source *lights[num_lights];

	extern char the_window[win_size][win_size];
	int i,j,x,y;
	light_ray ray;
	point eye_location = {win_size/2,win_size/2,-300};
	point pixel_location = {0,0,0,1};
	point dirn = {0,0,0,1};


	spheres[num_spheres-1] = sphereb();
	spheres[0] = spherea();

	lights[num_lights-1] = lightb();
	lights[0] = lighta();

	printf("raytracing \n");
	for (i=0;i<win_size;i++)
		{
		pixel_location[0] = (double)i + 20;
		for (j=0;j<win_size;j++)
			{
			pixel_location[1] = (double)j - 40;
			make_ray(&ray,eye_location,pixel_location);
			the_window[i][j] = RT_trace(ray,1,air,0.0);
			}
		}

}
void main()
	{
	   /* request auto detection */
	int gdriver = DETECT, gmode, errorcode;
	int x, y, color, maxx, maxy,
		maxcolor, seed;
	extern char the_window[win_size][win_size];
	ray_trace();

	/* initialize graphics and local variables */
	initgraph(&gdriver, &gmode, "");

	/* read result of initialization */
	errorcode = graphresult();
	/* an error occurred */
	if (errorcode != grOk)
		{
		printf("Graphics error: %s\n", grapherrormsg(errorcode));
		printf("Press any key to halt:");
		getch();
		/* terminate with an error code */
		exit(1);
		}

	for (x= 0;x<win_size;x++)
		for (y=0;y<win_size;y++)
			draw_pixel(x,y,the_window[x][y]);


	/* clean up */
	getch();
	closegraph();
	}