//----------------------------------------------------------------------------
// ObjectWindows - (C) Copyright 1991,1993 by Borland International
//----------------------------------------------------------------------------


//#include <owl\owlall.h>
#include <owl\owlpch.h>
#include <owl\applicat.h>
#include <owl\framewin.h>
#include <owl\listbox.h>
#include <owl\layoutwi.h>
#include <owl\static.h>
#include <owl\gdiobjec.h>
#include <owl\combobox.h>
#include <owl\button.h>
#include <owl\opensave.h>
#include <owl\menu.h>
#include <owl\editfile.rh>
#pragma hdrstop

#include <classlib\stacks.h>
#include <owl\editfile.rh>
#include <dir.h>
#include <stdlib.h>

#include "file.h"
#include "activity.h"
#include "menuitem.h"
#include "itemlist.h"
#include "menu.h"
#include "MenuList.h"
#include "inifile.h"   //dodgy

#include "filebrow.rh"

typedef TStack<int> MenuStack;  // a stack of menu numbers, to keep track of which
										  // menu to look at
typedef TStackIterator<int> MenuStackIterator;

const ID_FilePane        = 1;
const ID_FindPane        = 3;
const ID_FilePaneLabel   = 5;
const ID_Button			 = 6;

const CaptionHeight = 20;
const EditHeight    = 30; // Height of an edit control, with borders, in pixels
const ButtonWidth   = 40;
const MaxEntry      = MAXFILE+MAXEXT+4;
const WORD ID_BUTTON   = 101;


class TFileBrowser: public TApplication
{
  public:
	 TFileBrowser() : TApplication(0) {}

	 void InitMainWindow();
};


class TMyLayout: public TLayoutWindow
{
  public:
	 TMyLayout();
	 void SetupWindow();
	 void DisplayMenu();

	 // Notification Handlers
	 //
	 void SelectFile();
	 void HandleButtonMsg();  // ID_CHECKBOX
	 void CmFileOpen();
	 void CmFileExit();
	 void CmHelpAbout();


	 TFont*     CaptionFont;  // Used for pane labels
	 TStatic*   FilePaneLabel;
	 TListBox*  FilePane;
	 TWindow *	ButtonWindow;
	 TButton *	BackButton;

	 MyFile 		*fp;
	 MenuList 	*AllMenus;
	 MenuStack 	*MenuChoices;
	 Inifile 	*FileOptions;

  DECLARE_RESPONSE_TABLE(TMyLayout);
};

DEFINE_RESPONSE_TABLE1(TMyLayout,TLayoutWindow)
  EV_COMMAND(CM_FILEEXIT,CmFileExit),
  EV_COMMAND(CM_FILEOPEN,CmFileOpen),
  EV_COMMAND(CM_HELPABOUT,CmHelpAbout),
  EV_BN_CLICKED(ID_Button,HandleButtonMsg),
  EV_LBN_DBLCLK(ID_FilePane,SelectFile),
END_RESPONSE_TABLE;

void TMyLayout::CmHelpAbout()
	{
	MessageBox("Menu Program by \n Brian Austin 1994","Menu About");
	}
void TMyLayout::CmFileExit()
	{
	exit(0);
	}
void TMyLayout::CmFileOpen()
	{
	static TOpenSaveDialog::TData data (
	 OFN_HIDEREADONLY|OFN_FILEMUSTEXIST,
	 "Menu Files (*.MNU)|*.mnu|",
	 0,
	 "",
	 "MNU"
  );
  if (TFileOpenDialog(this, data).Execute() == IDOK) {
	 char FileTitle[MAXPATH];
	 TOpenSaveDialog::GetFileTitle(data.FileName, FileTitle, MAXPATH);
//	 strncpy(FileOptions->Files[ID_MenuFile]->FileName,FileOptions->Files[ID_MenuFile]->FileName,5);
	 strcpy(FileOptions->Files[ID_MenuFile]->FileName,FileTitle);
	 if (AllMenus)
		{
		delete AllMenus;
		}
	 if (MenuChoices)
		{
		delete MenuChoices;
		}
	 // save in ini file
	 FileOptions->WriteTo();

	 // open new menu file
	 fp = new MyFile(FileOptions->Files[ID_MenuFile]->FileName);

	 // create menu list
	 AllMenus = new MenuList(fp);

	 // create menustack
	 MenuChoices = new MenuStack();
	 MenuChoices->Push(0);

	 //display on window 
	 DisplayMenu();
	 // want to open the menu in question. delete current menu etc
	 //LoadBitmapFile(fileTitle);
	 //SetCaption(strlwr(fileTitle));
  }

	}

TMyLayout::TMyLayout() : TLayoutWindow(0), TWindow(0, 0, 0)
	{
	TLayoutMetrics lm;

	lm.X.Units = lm.Y.Units = lm.Width.Units = lm.Height.Units = lmPixels;

	// If layout window has a border, then it will automatically adjust
	// children by 1 pixel
	//
	Attr.Style |= WS_BORDER;
	// Find a font that will fit into our small captions and buttons
	//
	CaptionFont = new TFont(
	 "Small Fonts",              // facename
	 -(CaptionHeight),           // height,
	 0, 0, 0, FW_NORMAL,         // width, esc, orientation, weight
	 VARIABLE_PITCH | FF_SWISS,  // Pitch and Family
	 FALSE, FALSE, FALSE,        // Italic, Underline, Strikeout
	 ANSI_CHARSET,               // Charset
	 OUT_CHARACTER_PRECIS,       // Output precision
	 CLIP_DEFAULT_PRECIS,        // Clip precision
	 PROOF_QUALITY               // Quality
	);

  BackButton = new TButton(this, ID_Button, "Back", 0, 0, 0, 0);
  lm.Width.Absolute(ButtonWidth);
  lm.Height.Absolute(CaptionHeight);
  lm.X.SameAs(lmParent, lmLeft);
  lm.Y.SameAs(lmParent, lmTop);
  SetChildLayoutMetrics(*BackButton, lm);

	BackButton->SetWindowFont(*CaptionFont, FALSE);

	FilePaneLabel = new TStatic(this, ID_FilePaneLabel, " ", 0, 0, 0, 0, 0);
	FilePaneLabel->Attr.Style |= SS_CENTER;
	lm.Width.SameAs(lmParent, lmRight);
	lm.Y.SameAs(BackButton,lmTop);
	lm.X.RightOf(BackButton);
	lm.Height.Absolute(CaptionHeight);
	SetChildLayoutMetrics(*FilePaneLabel, lm);
	FilePaneLabel->SetWindowFont(*CaptionFont, FALSE);


	FilePane = new TListBox(this, ID_FilePane, 0, 0, 0, 0);

	// Prevent list box from adjusting it's size to avoid partial lines
	//
	FilePane->Attr.Style |= LBS_NOINTEGRALHEIGHT;

	lm.Width.SameAs(lmParent, lmRight);
	lm.Height.SameAs(lmParent, lmBottom);
   lm.X.SameAs(lmParent,lmLeft);
	lm.Y.Below(FilePaneLabel);
	SetChildLayoutMetrics(*FilePane, lm);

	}
void TMyLayout::HandleButtonMsg()
	{
	int i;
	i = MenuChoices->Pop();
	if (i==0)
		{
		MenuChoices->Push(i);
		}
	else
		DisplayMenu();
	}
void TMyLayout::DisplayMenu()
	{
	int Selected;	// fill list box with main menu
	FilePane->ClearList();

	Selected = MenuChoices->Pop();
	MenuChoices->Push(Selected);
	MenusIterator k(*AllMenus);
	Menu First;
	for (int i=0 ;i< Selected ;i++)
		{
		First = k++;
		}
	First = k++;
	FilePaneLabel->SetText(&First.Title[1]);

	ItemsIterator l(*First.Choices);
	while (l)
		{
		FilePane->AddString(l++.Label);
		}
	}
void TMyLayout::SetupWindow()
	{

	FileOptions = new Inifile();
	fp = new MyFile(FileOptions->Files[ID_MenuFile]->FileName);
	AllMenus = new MenuList(fp);
	MenuChoices = new MenuStack();
	MenuChoices->Push(0);
	TLayoutWindow::SetupWindow();
	DisplayMenu();
   delete fp;
	}

void TMyLayout::SelectFile()
	{
	int k;
	char newbuf[132];
	int searching = 1;
	int o;
	int n;

	int CurrentItemIndex = FilePane->GetSelIndex();

	// now do the action for the selected index

	//get correct menu
	int i;
	i = MenuChoices->Pop();
	MenuChoices->Push(i);
	MenusIterator j(*AllMenus);

	for (k=0;k<i;k++)
		j++;

	Menu CurrentMenu = j++;   // CurrentMenu is current menu displayed

	//get selected item
	ItemsIterator l(*CurrentMenu.Choices);
	for (k=0;k<CurrentItemIndex;k++)
		l++;

	MenuItem CurrentItem = l++; //CurrentItem is selected Item

	//act on activitylist
	ActivitiesIterator m(*CurrentItem.Activities);
	char SelectedActivity[132];
	strcpy(SelectedActivity,m++.c_str());
	while ((SelectedActivity[0] == ' ') || (SelectedActivity[0] == '\t'))
		strcpy(SelectedActivity,SelectedActivity+1);
	if (SelectedActivity[0]=='%')
		// go to next menu as described in SelectedActivity
		{
		j.Restart();
		k=0;
		while (searching)
			{
			o = strlen(SelectedActivity);
			if (!j) searching = 0;
			strcpy(newbuf,j.Current().Title);
			n = strlen(newbuf);
			if (!strncmp(newbuf,SelectedActivity,o<n?o:n))
				{
				searching = 0;
				MenuChoices->Push(k);
				DisplayMenu();
				};
			j++;
			k++;
			}

		}
	else
		// create, execute and delete a batch file
		{
		FILE *fp = fopen(FileOptions->Files[ID_TempFile]->FileName,"w");
		if (!fp)
			{
			MessageBox("Could not open temp file","Menu Error",MB_OK);
			}
		fprintf(fp,"@echo off \nrem This temporary file created by Brians menu program\n");
  		fprintf(fp,"%s\n",SelectedActivity);
		while (m)
			{
			strcpy(SelectedActivity,m++.c_str());
			fprintf(fp,"%s\n",SelectedActivity);
			};
		fclose(fp);
		WinExec(FileOptions->Files[ID_TempFile]->FileName,SW_SHOW);
		}
	}


void TFileBrowser::InitMainWindow()
	{
	MainWindow = new TFrameWindow(0, "Menu", new TMyLayout());
	MainWindow->SetIcon(this, ICON_1);

	MainWindow->AssignMenu(MENU_1);
	MainWindow->Attr.H = 300;
	MainWindow->Attr.W = 300;
	}



int OwlMain(int /*argc*/, char* /*argv*/ [])
	{
	return TFileBrowser().Run();
	}
