-- File: book.e
-- The class BOOK is a description of a book with title,author,barcode,status and
-- old_status
class BOOK
inherit 
	PRINTABLE

	redefine
		display,
		make
	end -- inherit PRINTABLE
	ANY
		redefine
			is_equal
	end -- inherit ANY

creation
	make
feature {ANY}

	title:string
	author:string
	barcode:string
	status : string   -- lost,stolen,on shelf,borrower's id
	old_status : STRING

-----------------------------------------------------------------------------
	save(tf : TEXTFILE) is
		do
			-- need to write a ! for book
			-- make writestring a concat of the book fields with ~ to separate them ??
			tf.insert(writestring,tf.count)
	end -- save
-----------------------------------------------------------------------------
	load(tf : TEXTFILE) is
		local
			readstring : STRING
			index : INTEGER
		do
		-- read a line of text.
		-- create book  & load fields from readstring
	end -- load

-----------------------------------------------------------------------------

	make is
		do
			!!io
			io.put_string("Enter the barcode: ")
			io.get_string
			barcode:=io.last_string
			set_status("On Shelf")
	end -- make

-----------------------------------------------------------------------------

-- The function returns a true value if the book is lost or stolen
	lost_or_stolen:BOOLEAN is
		do
		result := false
		if status.is_equal("Lost") or status.is_equal("Stolen") then
			result := true
		end --if
	end -- lost_or_stolen

-----------------------------------------------------------------------------

-- The function returns a true value if the book is on the shelf
	on_shelf : BOOLEAN is
		do
		result := false
		if status.is_equal("On Shelf") then
			result := true
		end -- if
	end -- on_shelf

-----------------------------------------------------------------------------

	set_status(new_status : string) is	-- Changes the status of the book
		do
			old_status := status
			status := new_status
	end -- set_status

-----------------------------------------------------------------------------

-- Gets the details of the book ie title and author
	get_detail	is
		do
			io.put_string("Enter the title of the book: ")
			io.get_string
			title := io.last_string
			io.put_string("Enter the author of the book: ")
			io.get_string
			author := io.last_string
	end -- get_detail

-----------------------------------------------------------------------------

-- Displays the barcode,title,author and the location of the book on the screen
	display is
		do
			io.put_string("Barcode: ")
			io.put_string(barcode);
			io.put_newline
			io.put_string("Title: ")
			io.put_string(title)
			io.put_newline
			io.put_string("Author: ")
			io.put_string(author)
			io.put_newline
			io.put_string("Location: ")
			io.put_string(status)
			io.put_newline
	end --display

-----------------------------------------------------------------------------

-- Does a comparison of 2 books barcode
	is_equal(other : BOOK) : BOOLEAN is
		do
			Result:=(barcode.is_equal(other.barcode))
	end -- is_equal
end --book
