#include "fraction.h"
#include <iostream.h>
#include <stdlib.h>
/************************************************************************
Fraction.cpp : 	All the calculations involved in the friend operators
				+,-,*,/,<< are here. No attempt was made to reduce the size of
                the numbers as it would have slowed the execution substantially.
                There would have been no inline substitution and for larger
                numbers the iterations involved would be large. As a result
                the numbers appear as 9/18 (1/3 + 1/6) instead of 1/2.
************************************************************************/



    /* multiplier: a/b * c/d = (a*c)/(b*d)   */
	rational operator *(rational &r1, rational &r2)
		{
		return rational(r1.num * r2.num,r1.den * r2.den);
		}
    /*divider: a/b / c/d = (a*d)/(b*c)    */
	rational operator /(rational &r1,rational &r2)
		{
		return rational(r1.num * r2.den, r1.den * r2.num);
		}
    /*Addition:	a/b + c/d = (a*d + c*b)/(b*d)  */
	rational operator +(rational &r1,rational &r2)
		{
		return rational((r1.num * r2.den) +(r2.num * r1.den), r1.den * r2.den);
		}
    /*Subtraction:	a/b - c/d = (a*d - c*b)/(b*d)  */
	rational operator -(rational &r1,rational &r2)
		{
		return rational((r1.num * r2.den) - (r2.num * r1.den), r1.den * r2.den);
		}
    /* to print to cout */
	ostream& operator <<(ostream& os,rational &r1)
		{
		char *str = (char *)(malloc(255));
		sprintf(str,"%ld / %ld",r1.num,r1.den);
		os << str;
		free(str);
		return os;
		}
