unit Main;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, TabNotBk, StdCtrls, Buttons, FileCtrl, DB, DBTables,
  Report;

type
  TTabbedNotebookDlg = class(TForm)
    TabbedNotebook1: TTabbedNotebook;
    DirectoryListBox1: TDirectoryListBox;
    DriveComboBox1: TDriveComboBox;
    FilterComboBox1: TFilterComboBox;
    Add: TBitBtn;
    DirectoryListBox2: TDirectoryListBox;
    Label2: TLabel;
    BitBtn1: TBitBtn;
    Label3: TLabel;
    Label4: TLabel;
    BitBtn2: TBitBtn;
    Label5: TLabel;
    Label6: TLabel;
    BitBtn3: TBitBtn;
    Label7: TLabel;
    Label8: TLabel;
    Label1: TLabel;
    Label9: TLabel;
    FilterComboBox2: TFilterComboBox;
    DriveComboBox2: TDriveComboBox;
    DriveComboBox3: TDriveComboBox;
    DirectoryListBox3: TDirectoryListBox;
    FileListBox1: TFileListBox;
    Label10: TLabel;
    CheckBox1: TCheckBox;
    Filedatabase: TDatabase;
    FileTable: TTable;
    Label11: TLabel;
    Reduce: TBitBtn;
    FileTableFNAME: TStringField;
    FileTableFDATE: TIntegerField;
    FileTableFSIZE: TIntegerField;
    FileTableFPATH: TStringField;
    Empty: TBitBtn;
    Latestfiles: TBitBtn;
    Report1: TReport;
    procedure DriveComboBox1Change(Sender: TObject);
    procedure AddClick(Sender: TObject);
    procedure DriveComboBox2Change(Sender: TObject);
    procedure DriveComboBox3Change(Sender: TObject);
    procedure DirectoryListBox3Change(Sender: TObject);
    procedure BuildDataBase(BaseDir : String ;Mask : String);
    Procedure ReduceDataBase(BaseDir : string;Mask : string) ;
    procedure ReduceClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure EmptyClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  TabbedNotebookDlg: TTabbedNotebookDlg;
  Filetable : ttable;

implementation

{$R *.DFM}

procedure TTabbedNotebookDlg.DriveComboBox1Change(Sender: TObject);
begin
DirectoryListBox1.Drive := DriveComboBox1.Drive;
end;


{**************************************************my code ******************}
Procedure TTabbedNotebookDlg.BuildDataBase(BaseDir : string;Mask : string) ;
var
   searchrec : tsearchrec;
begin

FindFirst(Basedir + '\' + mask, faAnyFile, SearchRec);
FindNext(SearchRec);
while (FindNext(SearchRec) = 0) do
   begin
   if (Searchrec.attr and faDirectory > 0) then
      begin
      BuildDataBase(BaseDir + '\' + Searchrec.name,Mask);
      end
   else
       begin
       FileTable.Insertrecord([SearchRec.Name,SearchRec.Time,SearchRec.Size,BaseDir]);
       end;
   {FileTable.appendrecord(Searchrec.Name.asstring,,BaseDir,Searchrec.Size);}
   end;
end;

Procedure TTabbedNotebookDlg.ReduceDataBase(BaseDir : string;Mask : string) ;
var
   searchrec : tsearchrec;
begin

FindFirst(Basedir + '\' + mask, faAnyFile, SearchRec);
FindNext(SearchRec);
while (FindNext(SearchRec) = 0) do
   begin
   if (Searchrec.attr and faDirectory > 0) then
      begin
      ReduceDataBase(BaseDir + '\' + Searchrec.name,Mask);
      end
   else
       begin
       if FileTable.FindKey([SearchRec.Name,SearchRec.Time,BaseDir])  then
             begin
             FileTable.delete;
             end;
       end;
   end;

end;

{***********************************************end of my code **************}
procedure TTabbedNotebookDlg.AddClick(Sender: TObject);
begin
{ search for all files on the drive matching the requisites
and put them in the database}
BuildDataBase(Directorylistbox1.directory,Filtercombobox1.mask);
end;

procedure TTabbedNotebookDlg.ReduceClick(Sender: TObject);
begin
ReduceDataBase(Directorylistbox1.directory,Filtercombobox1.mask);
end;


procedure TTabbedNotebookDlg.EmptyClick(Sender: TObject);
begin
with FileTable do
  begin
  Active := False;
  DatabaseName := 'filedb';
  TableName := 'FileTable';
  TableType := ttDefault;
  EmptyTable;
  end;
FileTable.Active:=true;

end;


procedure TTabbedNotebookDlg.DriveComboBox2Change(Sender: TObject);
begin
DirectoryListBox2.drive := Drivecombobox2.drive ;
end;

procedure TTabbedNotebookDlg.DriveComboBox3Change(Sender: TObject);
begin
directorylistbox3.drive := drivecombobox3.drive ;
end;

procedure TTabbedNotebookDlg.DirectoryListBox3Change(Sender: TObject);
begin
Filelistbox1.directory := directorylistbox3.directory ;
end;


procedure TTabbedNotebookDlg.FormActivate(Sender: TObject);
begin
FileTable.Active:=true;
end;

procedure TTabbedNotebookDlg.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
FileTable.Active:=False;
end;

end.
